<?php
/**
* @package phpBB-WAP
* @copyright (c) phpBB Group
* @Оптимизация под WAP: Гутник Игорь ( чел ).
* @简体中文：中文phpBB-WAP团队
* @license http://opensource.org/licenses/gpl-license.php
**/

/**
* 这是一款自由软件, 您可以在 Free Software Foundation 发布的
* GNU General Public License 的条款下重新发布或修改; 您可以
* 选择目前 version 2 这个版本（亦可以选择任何更新的版本，由
* 你喜欢）作为新的牌照.
**/

if ( !defined('IN_PHPBB') )
{
	die("Hacking attempt");
}

if ( $action == 'autologin' )
{
	$page_title = '规则_自动登录';
	
	require(ROOT_PATH . 'includes/page_header.php');
	
	$main_title = '自动登录';
	
	$template->set_filenames(array(
		'body' => 'rules/faq_login.tpl')
	);
	
	$template->assign_vars(array(
		'MAIN_TITLE' 	=> $main_title,
		'SCRIPT_PATH'	=> $board_config['server_name'] . $board_config['script_path'])
	);
	
	$template->pparse('body');
	
	require(ROOT_PATH . 'includes/page_tail.php');
}
elseif ( $action == 'bbcode' )
{
	$page_title = '规则_BB-Code';
	
	require(ROOT_PATH . 'includes/page_header.php');
	
	$main_title = 'BB-code';
	
	$template->set_filenames(array(
		'body' => 'rules/faq_bbcode.tpl')
	);
	$template->assign_vars(array(
		'MAIN_TITLE' 	=> $main_title)
	);
	
	$template->pparse('body');
	
	require(ROOT_PATH . 'includes/page_tail.php');
}
else if ($action == 'attach')
{
	require (ROOT_PATH . 'includes/rules/attach.php');
}
else if ($action == 'smiles')
{
	require (ROOT_PATH . 'includes/rules/smiles.php');
}
else
{
	
	$page_title = '规则_FAQ';
	
	require(ROOT_PATH . 'includes/page_header.php');
	
	$main_title = 'FAQ';
	
	$template->set_filenames(array(
		'body' => 'rules/faq_body.tpl')
	);
	$template->assign_vars(array(
		'MAIN_TITLE' 	=> $main_title,
		'U_AUTO_LOGIN'	=> append_sid('rules.php?mode=faq&amp;act=autologin'),
		'U_BBCODE'		=> append_sid('rules.php?mode=faq&amp;act=bbcode'),
		'U_SMILES'		=> append_sid('rules.php?mode=faq&amp;act=smiles'),
		'U_ATTACH'		=> append_sid('rules.php?mode=faq&amp;act=attach'),)
	);
	
	$template->pparse('body');
	
	require(ROOT_PATH . 'includes/page_tail.php');
}
?>