<?php
/**
* @package phpBB-WAP
* @copyright (c) phpBB Group
* @Оптимизация под WAP: Гутник Игорь ( чел ).
* @简体中文：中文phpBB-WAP团队
* @license http://opensource.org/licenses/gpl-license.php
**/

/**
* 这是一款自由软件, 您可以在 Free Software Foundation 发布的
* GNU General Public License 的条款下重新发布或修改; 您可以
* 选择目前 version 2 这个版本（亦可以选择任何更新的版本，由
* 你喜欢）作为新的牌照.
**/

if ( !defined('IN_PHPBB') )
{
	die('Hacking attempt');
}

$point_name = $board_config['points_name'];

if ( empty($_GET[POST_USERS_URL]) || $_GET[POST_USERS_URL] == ANONYMOUS )
{
	message_die(GENERAL_MESSAGE, '用户不存在');
}

$user = intval($_GET[POST_USERS_URL]);

if ( $user == $userdata['user_id'] )
{
	message_die(GENERAL_MESSAGE, '您不能转给您自己！');
}

$sql = "SELECT username 
	FROM " . USERS_TABLE . " 
	WHERE user_id = '$user'";
	
if ( !$result = $db->sql_query($sql) )
{
	message_die(GENERAL_ERROR, 'Could not obtain user information for sendpassword', '', __LINE__, __FILE__, $sql);
}

if ( !$row = $db->sql_fetchrow($result) )
{
	message_die(GENERAL_MESSAGE, '用户不存在');
}

$username = $row['username'];

if ( isset($_POST['submit']) && !empty($_POST['money_send']) )
{
	$money = intval($_POST['money_send']);
	
	if ( $userdata['user_level'] != ADMIN )
	{
		$money = abs($money);
	}

	if ( $money > $userdata['user_points'] && $userdata['user_level'] != ADMIN )
	{
		message_die(GENERAL_MESSAGE, '您没有足够的' . $point_name);
	}

	$sql = "UPDATE " . USERS_TABLE . "
		SET user_points = user_points + $money
		WHERE user_id = $user";
	if ( !($result = $db->sql_query($sql)) )
	{
		message_die(GENERAL_ERROR, 'Could not update users table', '', __LINE__, __FILE__, $sql);
	}

	if ( $userdata['user_level'] != ADMIN )
	{
		$sql = "UPDATE " . USERS_TABLE . "
			SET user_points = user_points - $money
			WHERE user_id = " . $userdata['user_id'];
		if ( !($result = $db->sql_query($sql)) )
		{
			message_die(GENERAL_ERROR, 'Could not update users table', '', __LINE__, __FILE__, $sql);
		}
	}

	message_die(GENERAL_MESSAGE, '已转给' . $username . $money . $point_name);
}
else
{
	$page_title = $point_name . '转账';
	include(ROOT_PATH . 'includes/page_header.php');

	$template->set_filenames(array(
		'body' => 'ucp/send_money.tpl')
	);

	if ( isset($_POST['submit']) && empty($_POST['money_send']) )
	{
		$template->set_filenames(array(
			'reg_header' => 'error_body.tpl')
		);
		$template->assign_vars(array(
			'ERROR_MESSAGE' => '<p>数量不能为空</p>')
		);
		$template->assign_var_from_handle('ERROR_BOX', 'reg_header');
	}

	$template->assign_vars(array(
		'USERNAME' 			=> $username,
		'U_USER_PROFILE'	=> append_sid('ucp.php?mode=viewprofile&amp;u=' . $user),
		'USER_MONEY' 		=> $userdata['user_points'],
		'POINT_NAME' 		=> $point_name,
		'S_POST_ACTION'		=> append_sid("ucp.php?mode=money&amp;u=$user"))
	);

	$template->pparse('body');

	include(ROOT_PATH . 'includes/page_tail.php');
}
?>