<?php
/**
* @package phpBB-WAP
* @copyright (c) phpBB Group
* @Оптимизация под WAP: Гутник Игорь ( чел ).
* @简体中文：中文phpBB-WAP团队
* @license http://opensource.org/licenses/gpl-license.php
**/

/**
* 这是一款自由软件, 您可以在 Free Software Foundation 发布的
* GNU General Public License 的条款下重新发布或修改; 您可以
* 选择目前 version 2 这个版本（亦可以选择任何更新的版本，由
* 你喜欢）作为新的牌照.
**/

define('IN_LOGIN', true);
define('IN_PHPBB', true);
define('ROOT_PATH', './');
require(ROOT_PATH . 'common.php');

if (isset($_GET['username']))
{
	$_POST['username'] = $_GET['username'];
	$_POST['password'] = $_GET['password'];
	$_POST['login'] = 'Enter';
	//如果使用_GET的方式来登录, 注销...
	unset( $_POST['logout'], $_POST['autologin'] );
}

$userdata = session_pagestart($user_ip, PAGE_LOGIN);
init_userprefs($userdata);

if( isset($_POST['login']) || isset($_GET['login']) || isset($_POST['logout']) || isset($_GET['logout']) )
{
	if( ( isset($_POST['login']) || isset($_GET['login']) ) && (!$userdata['session_logged_in'] || isset($_POST['admin'])) )
	{
		$username = isset($_POST['username']) ? phpbb_clean_username($_POST['username']) : '';
		$password = isset($_POST['password']) ? $_POST['password'] : '';
		//$password_select = md5($password); 
		  
		if ( filter_var($username, FILTER_VALIDATE_EMAIL) )
		{
			$sql = "SELECT user_id, username, user_password, user_active, user_level, user_login_tries, user_last_login_try, user_lastvisit
				FROM " . USERS_TABLE . "
				WHERE user_email = '" . str_replace("\\'", "''", $username) . "'";		
		}
		else
		{
			$sql = "SELECT user_id, username, user_password, user_active, user_level, user_login_tries, user_last_login_try, user_lastvisit
				FROM " . USERS_TABLE . "
				WHERE username = '" . str_replace("\\'", "''", $username) . "'"; 
		}
		
		if ( !($result = $db->sql_query($sql)) )
		{
			message_die(GENERAL_ERROR, '无法取得用户信息', '', __LINE__, __FILE__, $sql);
		}

		if( $row = $db->sql_fetchrow($result) )
		{
			if( $row['user_level'] != ADMIN && $board_config['board_disable'] )
			{
				redirect(append_sid('index.php', true));
			}
			else
			{
				if ($row['user_last_login_try'] && $board_config['login_reset_time'] && $row['user_last_login_try'] < (time() - ($board_config['login_reset_time'] * 60)))
				{
					$db->sql_query('UPDATE ' . USERS_TABLE . ' SET user_login_tries = 0, user_last_login_try = 0 WHERE user_id = ' . $row['user_id']);
					$row['user_last_login_try'] = $row['user_login_tries'] = 0;
				}

				if ($row['user_last_login_try'] && $board_config['login_reset_time'] && $board_config['max_login_attempts'] && 
					$row['user_last_login_try'] >= (time() - ($board_config['login_reset_time'] * 60)) && $row['user_login_tries'] >= $board_config['max_login_attempts'] && $userdata['user_level'] != ADMIN)
				{
					message_die(GENERAL_MESSAGE, '您已经连续输入错误密码 ' . $board_config['max_login_attempts'] . ' 次，请再过 ' . $board_config['login_reset_time'] . '分钟后再次尝试登录！');
				}

				if( md5($password) == $row['user_password'] && $row['user_active'] )
				{
					$sql = "SELECT user_regdate
						FROM " . USERS_TABLE . "
						WHERE user_id = ".$row['user_id'];
					if ( !($result = $db->sql_query($sql)) )
					{
						message_die(GENERAL_ERROR, 'Error in obtaining userdata', '', __LINE__, __FILE__, $sql);
					}
					if( $rowreg = $db->sql_fetchrow($result) )
					{
						$min_login_regdate = $board_config['min_login_regdate'] * 60;
						$time_activation = $rowreg['user_regdate'] + $min_login_regdate;
						$now_time = time();
						if ( $time_activation > $now_time )
						{
							$data_aktivacii = $time_activation - $now_time;
							$data_aktivacii_min = ceil($data_aktivacii / 60);
							message_die(GENERAL_MESSAGE, '当你注册成功那一刻起，您有 <strong> '.$board_config['min_login_regdate'].' </strong> 分钟的时间阅读<strong> <a href="' . append_sid('rules.php') . '">规则</a> </strong>，此期间您是不能登录的，还剩<strong> '.$data_aktivacii_min.' </strong>分钟');
						}
					}

					$autologin = ( isset($_POST['autologin']) ) ? TRUE : 0;

					$admin = (isset($_POST['admin'])) ? 1 : 0;
					$session_id = session_begin($row['user_id'], $user_ip, PAGE_INDEX, FALSE, $autologin, $admin);

					$db->sql_query('UPDATE ' . USERS_TABLE . ' SET user_login_tries = 0, user_last_login_try = 0 WHERE user_id = ' . $row['user_id']);

					if( $session_id )
					{
						$posl_visit = create_date($board_config['default_dateformat'], $row['user_lastvisit'], $board_config['board_timezone']);
						$url = ( !empty($_POST['redirect']) ) ? str_replace('&amp;', '&', htmlspecialchars($_POST['redirect'])) : 'index.php';
						//$template->assign_vars(array(
						//	'META' => '<meta http-equiv="refresh" content="3;url=' . append_sid($url, true) . '">')
						//);

						$login_infomation = '欢迎您：' . $row['username'] . '！<br />';
						$login_infomation .= ( $row['user_lastvisit'] != 0 ) ? '上次访问：' . $posl_visit . '<br />' : '';
						$login_infomation .= '浏览器：' . $user_agent . '<br />';
						$login_infomation .= 'IP地址：' . $client_ip . '<br />';
						$login_infomation .= '<a href="' . append_sid($url, true) . '">&lt;--快速进入</a><br/>';
						
						message_die(GENERAL_MESSAGE, $login_infomation);
				 	}
					else
					{
						message_die(CRITICAL_ERROR, 'Couldn\'t start session : login', '', __LINE__, __FILE__);
					}
				}
				else
				{
					if ($row['user_id'] != ANONYMOUS)
					{
						$sql = 'UPDATE ' . USERS_TABLE . '
							SET user_login_tries = user_login_tries + 1, user_last_login_try = ' . time() . '
							WHERE user_id = ' . $row['user_id'];
						if (!$db->sql_query($sql))
						{
							message_die(GENERAL_ERROR, '无法更新 users 表', '', __LINE__, __FILE__, $sql);
						}
					}
					
					$redirect = ( !empty($_POST['redirect']) ) ? str_replace('&amp;', '&', htmlspecialchars($_POST['redirect'])) : '';
					//$redirect = str_replace('?', '&', $redirect);

					if (strstr(urldecode($redirect), "\n") || strstr(urldecode($redirect), "\r") || strstr(urldecode($redirect), ';url'))
					{
						message_die(GENERAL_ERROR, 'Tried to redirect to potentially insecure url.');
					}

					//$template->assign_vars(array(
					//	'META' => "<meta http-equiv=\"refresh\" content=\"3;url=login.php?redirect=$redirect\">")
					//);

					$message = '帐号或密码错误！<br />点击 <a href="login.php?redirect=' . $redirect . '">这里</a>返回登录页面<br />点击 <a href="' . append_sid('index.php') . '">这里</a> 返回首页';

					message_die(GENERAL_MESSAGE, $message);
				}
			}
		}
		else
		{
			$redirect = ( !empty($_POST['redirect']) ) ? str_replace('&amp;', '&', htmlspecialchars($_POST['redirect'])) : '';
			//$redirect = str_replace("?", "&", $redirect);

			if (strstr(urldecode($redirect), "\n") || strstr(urldecode($redirect), "\r") || strstr(urldecode($redirect), ';url'))
			{
				message_die(GENERAL_ERROR, 'Tried to redirect to potentially insecure url.');
			}

			//$template->assign_vars(array(
			//	'META' => "<meta http-equiv=\"refresh\" content=\"3;url=login.php?redirect=$redirect\">")
			//);

			$message = '帐号或密码错误！<br />点击 <a href="login.php?redirect=' . $redirect . '">这里</a>返回登录页面<br />点击 <a href="' . append_sid('index.php') . '">这里</a> 返回首页';

			message_die(GENERAL_MESSAGE, $message);
		}
	}
	else if( ( isset($_GET['logout']) || isset($_POST['logout']) ) && $userdata['session_logged_in'] )
	{

		if( $userdata['session_logged_in'] )
		{
			session_end($userdata['session_id'], $userdata['user_id']);
		}

		if (!empty($_POST['redirect']) || !empty($_GET['redirect']))
		{
			$url = (!empty($_POST['redirect'])) ? htmlspecialchars($_POST['redirect']) : htmlspecialchars($_GET['redirect']);
			$url = str_replace('&amp;', '&', $url);
			redirect(append_sid($url, true));
		}
		else
		{
			//$template->assign_vars(array(
			//'META' => '<meta http-equiv="refresh" content="2;url=index.php">')
			//);
			message_die(GENERAL_MESSAGE, '欢迎下次访问！<br /><a href="index.php">&lt;--快速退出</a>');
		}
	}
	else
	{
		$url = ( !empty($_POST['redirect']) ) ? str_replace('&amp;', '&', htmlspecialchars($_POST['redirect'])) : 'index.php';
		//$template->assign_vars(array(
		//	'META' => '<meta http-equiv="refresh" content="3;url=' . append_sid($url, true) . '">')
		//);

		message_die(GENERAL_MESSAGE, '请点击确认！<br /><a href="' . append_sid($url, true) . '">确认--&gt;</a>');
	}
}
else
{

	if( !$userdata['session_logged_in'] || (isset($_GET['admin']) && $userdata['session_logged_in'] && !$userdata['session_admin'] && $userdata['user_level'] == ADMIN))
	{
		
		$page_title = '会员登录';

		$forward_page = '';

		if( isset($_POST['redirect']) || isset($_GET['redirect']) )
		{

			$forward_to = $_SERVER['QUERY_STRING'];

			if( preg_match("/^redirect=([a-z0-9\.#\/\?&=\+\-_]+)/si", $forward_to, $forward_matches) )
			{

				$forward_to = ( !empty($forward_matches[3]) ) ? $forward_matches[3] : $forward_matches[1];
				$forward_match = explode('&', $forward_to);

				if(count($forward_match) > 1)
				{
					for($i = 1; $i < count($forward_match); $i++)
					{
						if( !preg_match('/sid=/', $forward_match[$i]) )
						{
							if( $forward_page != '' )
							{
								$forward_page .= '&';
							}
							$forward_page .= $forward_match[$i];
						}
					}
					$forward_page = $forward_match[0] . '&' . $forward_page;
				}
				else
				{
					$forward_page = $forward_match[0];
				}
			}
		}

		$username = ( $userdata['user_id'] != ANONYMOUS ) ? $userdata['username'] : '';

		$s_hidden_fields = '<input type="hidden" name="redirect" value="' . $forward_page . '" />';

		if (isset($_GET['admin']) && $userdata['session_logged_in'] && !$userdata['session_admin'] && $userdata['user_level'] == ADMIN)
		{
			$template->assign_block_vars('admin', array());
			$s_hidden_fields .= '<input type="hidden" name="admin" value="1" />';
		}
		else
		{
			$s_hidden_fields .= '';
			$template->assign_block_vars('login', array());
		}
			
		require(ROOT_PATH . 'includes/page_header.php');

		$template->set_filenames(array(
			'body' => 'login_body.tpl')
		);

		$template->assign_vars(array(
			'USERNAME' 			=> $username,

			'U_SEND_PASSWORD' 	=> append_sid('ucp.php?mode=sendpassword'),
			'U_AUTOLOGIN' 		=> append_sid('rules.php?mode=faq&amp;act=autologin'),
			'S_LOGIN_ACTION'	=> append_sid('login.php'),
			'S_HIDDEN_FIELDS' 	=> $s_hidden_fields)
		);

		$template->pparse('body');

		require(ROOT_PATH . 'includes/page_tail.php');
	}
	else
	{
		redirect(append_sid('index.php', true));
	}
}
?>